function varargout = projector(varargin)
% PROJECTOR is a Graphic User Interface (GUI) fo displaying 3D images and its
% isolines.
% 
%     PROJECTOR(I) displays grayscale 3D image I in special GUI.
% 
%     PROJECTOR(I, A, v) displays grayscale 3D image I in special GUI and
%     draws a contour plot of matrix A with isoline specified in scalar v
% 
%     PROJECTOR(I, A, v, B, w) displays grayscale 3D image I in special GUI
%     and draws a contour plots of matrixes A and B with isolines specified
%     in scalars v and w


% PROJECTOR M-file for projector.fig
%      PROJECTOR, by itself, creates a new PROJECTOR or raises the existing
%      singleton*.
%
%      H = PROJECTOR returns the handle to a new PROJECTOR or the
%      handle to
%      the existing singleton*.
%
%      PROJECTOR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PROJECTOR.M with the given input arguments.
%
%      PROJECTOR('Property','Value',...) creates a new PROJECTOR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before projector13thEd_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to projector_OpeningFcn via
%      varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help projector

% Last Modified by GUIDE v2.5 08-Dec-2008 17:33:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @projector_OpeningFcn, ...
                   'gui_OutputFcn',  @projector_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%  Opening function  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes just before projector is made visible.
function projector_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to projector (see VARARGIN)

% turning off a warning caused by missing contour data at the active layer
warning off MATLAB:contour:ConstantData;

% number of input patrameters checking
switch length(varargin)
    case 0
        error('Not enough input arguments.');
    case 1
        handles.img = varargin{1};
    case 3
        if ~isequal(size(varargin{1}), size(varargin{2}))
            error('Size of input arrays must be same')
        end
        if ~isscalar(varargin{3})
            error('Isovalue must be scalar')
        end
        
        handles.img = varargin{1};
        handles.ePhi = varargin{2};
        handles.isovalues = varargin{3};
    case 5
        if ~isequal(size(varargin{1}), size(varargin{2}), size(varargin{4}))
            error('Size of input arrays must be same')
        end
        if ~isscalar(varargin{3}) || ~isscalar(varargin{5})
            error('Isovalues must be scalars')
        end
        
        handles.img = varargin{1};
        handles.ePhi = varargin{2};
        handles.isovalues = varargin{3};
        handles.ePhi2 = varargin{4};
        handles.isovalues(2) = varargin{5};
    otherwise
        error('Wrong number of input arguments');
end

% set number of slices in each plane
handles.numOfLevels = size(handles.img);
% set the first slice as actual in every plane
handles.level = round([handles.numOfLevels(1)/2,handles.numOfLevels(2)/2,handles.numOfLevels(3)/2]);

% initialization of sliders and text captions
set(handles.slider1, 'SliderStep',[1/handles.numOfLevels(1) 1/handles.numOfLevels(1)*3]);
set(handles.slider1, 'Max', handles.numOfLevels(1));
set(handles.slider1Text, 'String', sprintf('%d of %d', handles.level(1), handles.numOfLevels(1)));
set(handles.slider1, 'Value', round(handles.numOfLevels(1)/2));

set(handles.slider2, 'SliderStep',[1/handles.numOfLevels(2) 1/handles.numOfLevels(2)*3]);
set(handles.slider2, 'Max', handles.numOfLevels(2));
set(handles.slider2Text, 'String', sprintf('%d of %d', handles.level(2), handles.numOfLevels(2)));
set(handles.slider2, 'Value', round(handles.numOfLevels(2)/2));

set(handles.slider3, 'SliderStep',[1/handles.numOfLevels(3) 1/handles.numOfLevels(3)*3]);
set(handles.slider3, 'Max', handles.numOfLevels(3));
set(handles.slider3Text, 'String', sprintf('%d of %d', handles.level(3), handles.numOfLevels(3)));
set(handles.slider3, 'Value', round(handles.numOfLevels(3)/2));

% saving minimal and maximal intensity of the volume image data
handles.minIntensity = min(handles.img(:));
handles.maxIntensity = max(handles.img(:));

handles.colormap.actualCmap = repmat((0:255)/255, 3, 1)'; 
handles.colormap.initialCmap = repmat((0:255)/255, 3, 1)'; 
handles.colormap.beta = 0;
handles.colormap.contrast.in = [0 1];
handles.colormap.contrast.out = [0 1];

% compute axes size and position
computeAxesSizeAndPosition(handles);

handles.linesHandles.x1 = [];
handles.linesHandles.x2 = [];
handles.linesHandles.x3 = [];
handles.linesHandles.y1 = [];
handles.linesHandles.y2 = [];
handles.linesHandles.y3 = [];
handles.axes1AuxHandles.hIm = [];
handles.axes2AuxHandles.hIm = [];
handles.axes3AuxHandles.hIm = [];

% display initial slices in each plane
handles = redrawFigure(hObject, eventdata, handles, 1);
handles = redrawFigure(hObject, eventdata, handles, 2);
handles = redrawFigure(hObject, eventdata, handles, 3);

% make scroll and overview panel
handles = makeScrollAndOverviewPanels(handles);

% display title (not functional because of scroll panel)
title(handles.axes1, 'Frontal', 'FontSize', 13);
title(handles.axes2, 'Sagittal', 'FontSize', 13);
title(handles.axes3, 'Transverse', 'FontSize', 13);

% Choose default command line output for projector
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes projector wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = projector_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%  nextButt_Callback  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on 'Next level' button press
function nextButt_Callback(hObject, eventdata, handles)
% hObject    handle to nextButtD3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% select current dimension, slider and text caption handle
switch hObject
    case handles.nextButtD1
        dim = 1;
        sliderHandle = handles.slider1;
        sliderTextHandle = handles.slider1Text;
    case handles.nextButtD2
        dim = 2;
        sliderHandle = handles.slider2;
        sliderTextHandle = handles.slider2Text;
    case handles.nextButtD3
        dim = 3;
        sliderHandle = handles.slider3;
        sliderTextHandle = handles.slider3Text;
end

if handles.level(dim) < handles.numOfLevels(dim)
% decrement number of actual level
    handles.level(dim) = handles.level(dim)+1;
% display new slice
    handles = redrawFigure(hObject, eventdata, handles, dim);
% plot slice-identifying lines to the other axes
    drawLines(hObject, eventdata, handles, dim);
% update overview panel, slider positon and text caption
    redrawOverviewPanel(handles, dim);
    set(sliderHandle, 'Value', handles.level(dim));
    set(sliderTextHandle, 'String', sprintf('%d of %d', handles.level(dim), handles.numOfLevels(dim)));
    
% save the data
    guidata(hObject, handles);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%  prevButt_Callback  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on 'Previous level' button press
function prevButt_Callback(hObject, eventdata, handles)
% hObject    handle to prevButtD3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% select current dimension, slider and text caption handle
switch hObject
    case handles.prevButtD1
        dim = 1;
        sliderHandle = handles.slider1;
        sliderTextHandle = handles.slider1Text;
    case handles.prevButtD2
        dim = 2;
        sliderHandle = handles.slider2;
        sliderTextHandle = handles.slider2Text;
    case handles.prevButtD3
        dim = 3;
        sliderHandle = handles.slider3;
        sliderTextHandle = handles.slider3Text;
end

if handles.level(dim) > 1
% decrement number of actual level
    handles.level(dim) = handles.level(dim)-1;
% display new slice
    handles = redrawFigure(hObject, eventdata, handles, dim);
% plot slice-identifying lines to the other axes
    drawLines(hObject, eventdata, handles, dim);
% update overview panel, slider positon and text caption
    redrawOverviewPanel(handles, dim);
    set(sliderHandle, 'Value', handles.level(dim));
    set(sliderTextHandle, 'String', sprintf('%d of %d', handles.level(dim), handles.numOfLevels(dim)));
    
% save the data
    guidata(hObject, handles);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%  slider_Callback  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on slider movement.
function slider_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% select current dimension and text caption handle
switch hObject
    case handles.slider1
        dim = 1;
        sliderTextHandle = handles.slider1Text;
    case handles.slider2
        dim = 2;
        sliderTextHandle = handles.slider2Text;
    case handles.slider3
        dim = 3;
        sliderTextHandle = handles.slider3Text;
end

% update actual level dependig to slider position
handles.level(dim) = round(get(hObject,'Value'));
% display new slice
handles = redrawFigure(hObject, eventdata, handles, dim);
% plot slice-identifying lines to the other axes
drawLines(hObject, eventdata, handles, dim);
% update overview panel and text caption
redrawOverviewPanel(handles, dim);
set(sliderTextHandle, 'String', sprintf('%d of %d', handles.level(dim), handles.numOfLevels(dim)));

% save the data
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  redrawFigure  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Redraws figure
function handles = redrawFigure(hObject, eventdata, handles, dim)
% hObject    handle to prevButtD3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

switch dim
    case 1
%         display the actual slice in the current axes
        axes(handles.axes1);
%         delete(handles.axes1AuxHandles.hIm);
        handles.axes1AuxHandles.hIm = imshow(squeeze(handles.img(handles.level(1),:,:))', [handles.minIntensity handles.maxIntensity]);
        colormap(handles.colormap.actualCmap); hold on;
        
%         draw isoline of the second input matrix (optional)
        if isfield(handles,'ePhi')
            contour(squeeze(handles.ePhi(handles.level(1),:,:))',[handles.isovalues(1) handles.isovalues(1)],'r','LineWidth',2);
        end
%         draw isoline of the third input matrix (optional)
        if isfield(handles,'ePhi2')
            contour(squeeze(handles.ePhi2(handles.level(1),:,:))',[handles.isovalues(2) handles.isovalues(2)],'y:','LineWidth',2);
        end
        
%         plot lines to current axes, that identify currently displayed slices in the other planes 
        delete(handles.linesHandles.x1);
        delete(handles.linesHandles.y1);
        handles.linesHandles.x1 = line([1 handles.numOfLevels(2)], [handles.level(3) handles.level(3)], 'Color', 'y');
        handles.linesHandles.y1 = line([handles.level(2) handles.level(2)], [1 handles.numOfLevels(3)], 'Color', 'y');

%         axis equal;
    case 2
%         display the actual slice in current axes
        axes(handles.axes2);
%         delete(handles.axes2AuxHandles.hIm);
        handles.axes2AuxHandles.hIm = imshow(squeeze(handles.img(:,handles.level(2),:)), [handles.minIntensity handles.maxIntensity]);
        colormap(handles.colormap.actualCmap); hold on;
        
%         draw isoline of the second input matrix (optional)
        if isfield(handles,'ePhi')
            contour(squeeze(handles.ePhi(:,handles.level(2),:)),[handles.isovalues(1) handles.isovalues(1)],'r','LineWidth',2);
        end
%         draw isoline of the third input matrix (optional)
        if isfield(handles,'ePhi2')
            contour(squeeze(handles.ePhi2(:,handles.level(2),:)),[handles.isovalues(2) handles.isovalues(2)],'y:','LineWidth',2);
        end
        
%         plot lines to current axes, that identify currently displayed slices in the other planes
        delete(handles.linesHandles.x2);
        delete(handles.linesHandles.y2);
        handles.linesHandles.x2 = line([1 handles.numOfLevels(3)], [handles.level(1) handles.level(1)], 'Color', 'y');
        handles.linesHandles.y2 = line([handles.level(3) handles.level(3)], [1 handles.numOfLevels(1)], 'Color', 'y');
        
%         axis equal;
    case 3
%         display the actual slice in the current axes
        axes(handles.axes3);
%         delete(handles.axes3AuxHandles.hIm);
        handles.axes3AuxHandles.hIm = imshow(squeeze(handles.img(:,:,handles.level(3))), [handles.minIntensity handles.maxIntensity]);
        colormap(handles.colormap.actualCmap); hold on;

%         draw isoline of the second input matrix (optional)
        if isfield(handles,'ePhi')
            contour(squeeze(handles.ePhi(:,:,handles.level(3))),[handles.isovalues(1) handles.isovalues(1)],'r','LineWidth',2);
        end
%         draw isoline of the third input matrix (optional)
        if isfield(handles,'ePhi2')
            contour(squeeze(handles.ePhi2(:,:,handles.level(3))),[handles.isovalues(2) handles.isovalues(2)],'y:','LineWidth',2);
        end

%         plot lines to current axes, that identify currently displayed slices in the other planes
        delete(handles.linesHandles.x3);
        delete(handles.linesHandles.y3);
        handles.linesHandles.x3 = line([1 handles.numOfLevels(2)], [handles.level(1) handles.level(1)], 'Color', 'y');
        handles.linesHandles.y3 = line([handles.level(2) handles.level(2)], [1 handles.numOfLevels(1)], 'Color', 'y');
        
%         axis equal;
end

% length(findobj('Type','Image'))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  drawLines  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Draws slice cut lines
function drawLines(hObject, eventdata, handles, dim)
% hObject    handle to prevButtD3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

switch dim
    case 1
        %  horizontal line axes 1
        set(handles.linesHandles.x3, 'XData', [1 handles.numOfLevels(2)], 'YData', [handles.level(1) handles.level(1)]);
        
        %  horizontal line axes 2
        set(handles.linesHandles.x2, 'XData', [1 handles.numOfLevels(3)], 'YData', [handles.level(1) handles.level(1)]);        
        
    case 2
        %  vertical line axes 1
        set(handles.linesHandles.y1, 'XData', [handles.level(2) handles.level(2)], 'YData', [1 handles.numOfLevels(3)]);        

        %  vertical line axes 3
        set(handles.linesHandles.y3, 'XData', [handles.level(2) handles.level(2)], 'YData', [1 handles.numOfLevels(1)]);        

    case 3
        
        %  horizontal line axes 1
        set(handles.linesHandles.x1, 'XData', [1 handles.numOfLevels(2)], 'YData', [handles.level(3) handles.level(3)]);
        
        %  vertical line axes 2
        set(handles.linesHandles.y2, 'XData', [handles.level(3) handles.level(3)], 'YData', [1 handles.numOfLevels(1)]);

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%  figureButtonDownFcn_Callback  %%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function figureButtonDownFcn_Callback(hObject, eventdata, handles)

% get coordinates of current pixel
fig = gcbf;
ax = get(fig, 'CurrentAxes');

clickPos = get(fig,'CurrentPoint');
% clickInsideAxesTest(clickPos, handles);

if ~clickInsideAxesTest(clickPos, handles) %(isempty(ax))
%     disp('Klepnuls mimo :-)');
   return;
else
   aPos = get(ax,'CurrentPoint');
end;

if (strcmp(get(gcf,'SelectionType'), 'alt'))
    handles.CurrentPoint_old = round(aPos);
    guidata(hObject, handles);
    return;
end

x = round(aPos(1,1));
y = round(aPos(1,2));

% select correct lines to move, slider and number of slice text to update
% depending on current axes
switch ax
    case handles.axes1
        dim = 1;
        xDim = 2;
        yDim = 3;
        
        xLineHandle = handles.linesHandles.x1;
        yLineHandle = handles.linesHandles.y1;
        
        sliderHandle1 = handles.slider2;
        sliderTextHandle1 = handles.slider2Text;
        sliderHandle2 = handles.slider3;
        sliderTextHandle2 = handles.slider3Text;
    case handles.axes2
        dim = 2;
        xDim = 3;
        yDim = 1;
        
        xLineHandle = handles.linesHandles.x2;
        yLineHandle = handles.linesHandles.y2;
        
        sliderHandle1 = handles.slider3;
        sliderTextHandle1 = handles.slider3Text;
        sliderHandle2 = handles.slider1;
        sliderTextHandle2 = handles.slider1Text;
    case handles.axes3
        dim = 3;
        xDim = 2;
        yDim = 1;
        
        xLineHandle = handles.linesHandles.x3;
        yLineHandle = handles.linesHandles.y3;
        
        sliderHandle1 = handles.slider2;
        sliderTextHandle1 = handles.slider2Text;
        sliderHandle2 = handles.slider1;
        sliderTextHandle2 = handles.slider1Text;
    otherwise
        return;    
end


if ((x > 0) & (y > 0) & (x <= handles.numOfLevels(xDim)) & (y <= handles.numOfLevels(yDim)))
    
%     update number of actual slice in the other planes
    handles.level(xDim) = x;
    handles.level(yDim) = y;

%     update lines positions
    %  horizontal line
    set(xLineHandle, 'XData', [1 handles.numOfLevels(xDim)], 'YData', [handles.level(yDim) handles.level(yDim)]);
        
    %  vertical line
    set(yLineHandle, 'XData', [handles.level(xDim) handles.level(xDim)], 'YData', [1 handles.numOfLevels(yDim)]);
    
%     show new slices in the other planes and update data (axes, overview
%     panels, sliders, text captions)
    handles = redrawFigure(hObject, eventdata, handles, xDim);
    redrawOverviewPanel(handles, xDim);
    set(sliderHandle1, 'Value', handles.level(xDim));
    set(sliderTextHandle1, 'String', sprintf('%d of %d', handles.level(xDim), handles.numOfLevels(xDim)));
    
    handles = redrawFigure(hObject, eventdata, handles, yDim);
    redrawOverviewPanel(handles, yDim);
    set(sliderHandle2, 'Value', handles.level(yDim));
    set(sliderTextHandle2, 'String', sprintf('%d of %d', handles.level(yDim), handles.numOfLevels(yDim)));
    
end

% save data (number of actual slices)
guidata(hObject, handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%  figureButtonMotionFcn_Callback  %%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function figureButtonMotionFcn_Callback(hObject, eventdata, handles)

% get coordinates of current pixel
fig = gcbf;
ax = get(fig, 'CurrentAxes');

clickPos = get(fig,'CurrentPoint');

if ~strcmp(get(gcf,'SelectionType'), 'alt')
%     disp('Klepnuls mimo :-)');
   return;
elseif ~clickInsideAxesTest(clickPos, handles)
    return;
else
   aPos = get(ax,'CurrentPoint');
end;

x = round(aPos(1,1));
y = round(aPos(1,2));

% disp(x);

% mouseSensitivity = 0;
% disp(sprintf('Horizontal shift =  %d, vertical shift = %d\n', x - handles.CurrentPoint_old(1), y - handles.CurrentPoint_old(2)));
% disp(sprintf('Beta = %.4f, con. IN %.2f %.2f, OUT %.2f %.2f\n', handles.colormap.beta, handles.colormap.contrast.in(1), handles.colormap.contrast.in(2), handles.colormap.contrast.out(1), handles.colormap.contrast.out(2)));

betaShift = 0.01;
if (x - handles.CurrentPoint_old(1) > 0 && handles.colormap.beta < 1-betaShift)
    handles.colormap.beta = handles.colormap.beta + betaShift;
elseif (x - handles.CurrentPoint_old(1) < 0 && handles.colormap.beta > -1+betaShift)
    handles.colormap.beta = handles.colormap.beta - betaShift;
end

% disp(sprintf('Beta = %.4f\n', handles.colormap.beta));


% disp(sprintf('BEFORE Contrast IN %.2f %.2f, contrast OUT %.2f %.2f\n', handles.colormap.contrast.in(1), handles.colormap.contrast.in(2), handles.colormap.contrast.out(1), handles.colormap.contrast.out(2)));
contrastShift = 0.01;
if (y - handles.CurrentPoint_old(2) > 0)
    if (handles.colormap.contrast.out(1) >= contrastShift)
        handles.colormap.contrast.out = [handles.colormap.contrast.out(1)-contrastShift handles.colormap.contrast.out(2)+contrastShift];
    elseif (handles.colormap.contrast.in(1) <= 0.5-contrastShift)
        handles.colormap.contrast.in = [handles.colormap.contrast.in(1)+contrastShift handles.colormap.contrast.in(2)-contrastShift];
    end
end

if (y - handles.CurrentPoint_old(2) < 0)
    if (handles.colormap.contrast.in(1) >= contrastShift)
        handles.colormap.contrast.in = [handles.colormap.contrast.in(1)-contrastShift handles.colormap.contrast.in(2)+contrastShift];
    elseif (handles.colormap.contrast.out(1) <= 0.5-contrastShift)
        handles.colormap.contrast.out = [handles.colormap.contrast.out(1)+contrastShift handles.colormap.contrast.out(2)-contrastShift];
    end
end


% disp(sprintf('AFTER Contrast IN %.2f %.2f, contrast OUT %.2f %.2f\n', handles.colormap.contrast.in(1), handles.colormap.contrast.in(2), handles.colormap.contrast.out(1), handles.colormap.contrast.out(2)));

handles.colormap.actualCmap = brighten(handles.colormap.initialCmap, handles.colormap.beta);
handles.colormap.actualCmap = imadjust(handles.colormap.actualCmap, handles.colormap.contrast.in, handles.colormap.contrast.out);

colormap(handles.colormap.actualCmap);

handles.CurrentPoint_old = [x y];

% save data (number of actual slices)
guidata(hObject, handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%  figureButtonUpFcn_Callback  %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function figureButtonUpFcn_Callback(hObject, eventdata, handles)

% get coordinates of current pixel
fig = gcbf;
ax = get(fig, 'CurrentAxes');

if (isempty(ax) || ~strcmp(get(gcf,'SelectionType'), 'alt'))
%     disp('Klepnuls mimo :-)');
   return;
else
   set(gcf,'SelectionType', 'normal');
end;

% fig = figure;
% % aux = squeeze(handles.cmap);
% hist(handles.cmap(:), (1:256)/256);


% switch ax
%     case handles.axes1
%         disp('Axes 1');
%     case handles.axes2
%         disp('Axes 2');
%     case handles.axes3
%         disp('Axes 3');
%     otherwise
%         disp('No axes');
% end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%  clickInsideAxesTest  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function clickInsideAxes = clickInsideAxesTest(clickPos, handles)

scrollPanel1Pos = get(handles.axes1AuxHandles.hSP, 'Position');
scrollPanel2Pos = get(handles.axes2AuxHandles.hSP, 'Position');
scrollPanel3Pos = get(handles.axes3AuxHandles.hSP, 'Position');

if (((clickPos(1) >= scrollPanel1Pos(1)) && (clickPos(1) <= scrollPanel1Pos(1)+scrollPanel1Pos(3))) &&...
        ((clickPos(2) >= scrollPanel1Pos(2)) && (clickPos(2) <= scrollPanel1Pos(2)+scrollPanel1Pos(4))))
%     disp('Click inside axes 1');
    clickInsideAxes = 1;
    return;
elseif (((clickPos(1) >= scrollPanel2Pos(1)) && (clickPos(1) <= scrollPanel2Pos(1)+scrollPanel2Pos(3))) &&...
        ((clickPos(2) >= scrollPanel2Pos(2)) && (clickPos(2) <= scrollPanel2Pos(2)+scrollPanel2Pos(4))))
%     disp('Click inside axes 2');
    clickInsideAxes = 1;
    return;
elseif (((clickPos(1) >= scrollPanel3Pos(1)) && (clickPos(1) <= scrollPanel3Pos(1)+scrollPanel3Pos(3))) &&...
        ((clickPos(2) >= scrollPanel3Pos(2)) && (clickPos(2) <= scrollPanel3Pos(2)+scrollPanel3Pos(4))))
%     disp('Click inside axes 3');
    clickInsideAxes = 1;
    return;
else
%     disp('Click outside any axes');
    clickInsideAxes = 0;
    return;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%  makeScrollAndOverviewPanels  %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function handles = makeScrollAndOverviewPanels(handles)

% get figure position in pixels and normalized units
set(handles.figure1, 'Units', 'pixel');
figurePosPix = get(handles.figure1, 'Position');
set(handles.figure1, 'Units', 'normalized');
figurePosNorm = get(handles.figure1, 'Position');

% compute absolute figure side ratio
figureWxHRatio = figurePosPix(3) / figurePosPix(4);

% get axes position for scrollpanel sizing and positioning
axes1Pos = get(handles.axes1, 'Position');
axes2Pos = get(handles.axes2, 'Position');
axes3Pos = get(handles.axes3, 'Position');

% scroll and overview panel 1
   % create scroll panel 1 and set its size and position to fit axes 1
handles.axes1AuxHandles.hSP = imscrollpanel(handles.figure1, handles.axes1AuxHandles.hIm);
set(handles.axes1AuxHandles.hSP, 'Units', 'normalized', 'Position', axes1Pos);

   % get axes1 API handle
handles.axes1AuxHandles.api = iptgetapi(handles.axes1AuxHandles.hSP);
   % find fit magnification and save it as inital
handles.axes1AuxHandles.initialMag = handles.axes1AuxHandles.api.findFitMag();
   % set axes 1 initial magnification
handles.axes1AuxHandles.api.setMagnification(handles.axes1AuxHandles.initialMag);

   % create overview panel 1 and set its size and position
handles.axes1AuxHandles.hOvPanel = imoverviewpanel(handles.figure1, handles.axes1AuxHandles.hIm);
set(handles.axes1AuxHandles.hOvPanel, 'Units', 'Normalized');
set(handles.axes1AuxHandles.hOvPanel, 'Position', [0.7625 0.7 0.1 0.1*figureWxHRatio]);

% scroll and overview panel 2
   % create scroll panel 2 and set its size and position to fit axes 2
handles.axes2AuxHandles.hSP = imscrollpanel(handles.figure1, handles.axes2AuxHandles.hIm);
set(handles.axes2AuxHandles.hSP, 'Units', 'normalized', 'Position', axes2Pos);

   % get axes2 API handle
handles.axes2AuxHandles.api = iptgetapi(handles.axes2AuxHandles.hSP);
   % find fit magnification and save it as inital
handles.axes2AuxHandles.initialMag = handles.axes2AuxHandles.api.findFitMag();
   % set axes 2 initial magnification
handles.axes2AuxHandles.api.setMagnification(handles.axes2AuxHandles.initialMag);

   % create overview panel 2 and set its size and position
handles.axes2AuxHandles.hOvPanel = imoverviewpanel(handles.figure1, handles.axes2AuxHandles.hIm);
set(handles.axes2AuxHandles.hOvPanel, 'Units', 'Normalized');
set(handles.axes2AuxHandles.hOvPanel, 'Position', [0.8875 0.5 0.1 0.1*figureWxHRatio]);

% scroll and overview panel 3
   % create scroll panel 3 and set its size and position to fit axes 3
handles.axes3AuxHandles.hSP = imscrollpanel(handles.figure1, handles.axes3AuxHandles.hIm);
set(handles.axes3AuxHandles.hSP, 'Units', 'normalized', 'Position', axes3Pos);

   % get axes3 API handle
handles.axes3AuxHandles.api = iptgetapi(handles.axes3AuxHandles.hSP);
   % find fit magnification and save it as inital
handles.axes3AuxHandles.initialMag = handles.axes3AuxHandles.api.findFitMag();
   % set axes 3 initial magnification
handles.axes3AuxHandles.api.setMagnification(handles.axes3AuxHandles.initialMag);

   % create overview panel 3 and set its size and position
handles.axes3AuxHandles.hOvPanel = imoverviewpanel(handles.figure1, handles.axes3AuxHandles.hIm);
set(handles.axes3AuxHandles.hOvPanel, 'Units', 'Normalized');
set(handles.axes3AuxHandles.hOvPanel, 'Position', [0.7625 0.9 0.1 0.1*figureWxHRatio]);

% compute overview panel size and position
computeOverviewPanelSizeAndPosition(handles, figureWxHRatio);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%  computeOverviewPanelSizeAndPosition  %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function computeOverviewPanelSizeAndPosition(handles, figureWxHRatio)

set(handles.magEdit1, 'Units', 'normalized');
set(handles.magEdit2, 'Units', 'normalized');
set(handles.magEdit3, 'Units', 'normalized');

magEdit1Pos = get(handles.magEdit1, 'Position');
magEdit2Pos = get(handles.magEdit2, 'Position');
magEdit3Pos = get(handles.magEdit3, 'Position');

zoomPanelPos = get(handles.zoomPanel, 'Position');

oVPanelWidth = 0.085;
oVPanelHeight = oVPanelWidth * figureWxHRatio;

zoomPanelPos = [0.7625 1-0.025-2*magEdit1Pos(4)-2*oVPanelHeight-0.085 0.225 2*magEdit1Pos(4)+2*oVPanelHeight+0.085];
set(handles.zoomPanel, 'Position', zoomPanelPos);

oVPanel1Pos = [zoomPanelPos(1)+0.0125 zoomPanelPos(2)+0.0125+magEdit1Pos(4)+0.0125 oVPanelWidth oVPanelHeight];
oVPanel2Pos = [oVPanel1Pos(1)+oVPanelWidth+0.025 oVPanel1Pos(2)+oVPanelHeight+0.025 oVPanelWidth oVPanelHeight];
oVPanel3Pos = [oVPanel1Pos(1) oVPanel2Pos(2) oVPanelWidth oVPanelHeight];

magEdit1Pos(1:2) = [zoomPanelPos(1)+0.0125+oVPanelWidth/2-magEdit1Pos(3)/2 zoomPanelPos(2)+0.0125];
magEdit2Pos(1:2) = [oVPanel2Pos(1)+oVPanelWidth/2-magEdit2Pos(3)/2 oVPanel2Pos(2)-0.0125-magEdit2Pos(4)];
magEdit3Pos(1:2) = [magEdit1Pos(1) oVPanel3Pos(2)+oVPanel3Pos(4)+0.0125];

set(handles.magEdit1, 'Position', magEdit1Pos);
set(handles.magEdit2, 'Position', magEdit2Pos);
set(handles.magEdit3, 'Position', magEdit3Pos);

set(handles.percentText1, 'Units', 'Normalized');
set(handles.percentText2, 'Units', 'Normalized');
set(handles.percentText3, 'Units', 'Normalized');

percentTextPos = get(handles.percentText1, 'Position');

set(handles.percentText1, 'Position', [magEdit1Pos(1)+magEdit1Pos(3) magEdit1Pos(2)-0.0035 percentTextPos(3) percentTextPos(4)]);
set(handles.percentText2, 'Position', [magEdit2Pos(1)+magEdit2Pos(3) magEdit2Pos(2)-0.0035 percentTextPos(3) percentTextPos(4)]);
set(handles.percentText3, 'Position', [magEdit3Pos(1)+magEdit3Pos(3) magEdit3Pos(2)-0.0035 percentTextPos(3) percentTextPos(4)]);

set(handles.axes1AuxHandles.hOvPanel, 'Position', oVPanel1Pos);
set(handles.axes2AuxHandles.hOvPanel, 'Position', oVPanel2Pos);
set(handles.axes3AuxHandles.hOvPanel, 'Position', oVPanel3Pos);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%  redrawOverviewPanel  %%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function redrawOverviewPanel(handles, dim)

% select overview panel handle and actual slice with respect to acuatl axes
switch dim
    case 1
        oVPanelHandle = handles.axes1AuxHandles.hOvPanel;
        actualSlice = squeeze(handles.img(handles.level(1),:,:))';
    case 2
        oVPanelHandle = handles.axes2AuxHandles.hOvPanel;
        actualSlice = squeeze(handles.img(:,handles.level(2),:));
    case 3
        oVPanelHandle = handles.axes3AuxHandles.hOvPanel;
        actualSlice = squeeze(handles.img(:,:,handles.level(3)));
end

% get and set as actual overview panel axes
ovPanelAxes = get(oVPanelHandle, 'children');
        
axes(ovPanelAxes);

% display actual slice in overview panel        
hold on; imshow(actualSlice, [handles.minIntensity handles.maxIntensity]);
colormap(handles.colormap.actualCmap);

% the first children of overview panel axes must be the detail rectangle,
% second is actual slice and third is initial slice (it is necessary for
% proper overview panel functionality), all other children are deleted
ovPanelAxesChildren = get(ovPanelAxes, 'Children');
set(ovPanelAxes, 'Children', [ovPanelAxesChildren(2) ovPanelAxesChildren(1) ovPanelAxesChildren(end) ovPanelAxesChildren(3:end-1)']);
ovPanelAxesChildren = get(ovPanelAxes, 'Children');
delete(ovPanelAxesChildren(3:end));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%  magEdit_Callback  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function magEdit_Callback(hObject, eventdata, handles)
% hObject    handle to magEdit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of magEdit1 as text
%        str2double(get(hObject,'String')) returns contents of magEdit1 as a double

switch hObject
    case handles.magEdit1
        newMag = str2double(get(handles.magEdit1, 'String'));
        if isnan(newMag), newMag = 100; end;
        handles.axes1AuxHandles.api.setMagnification(handles.axes1AuxHandles.initialMag * newMag/100);
    case handles.magEdit2
        newMag = str2double(get(handles.magEdit2, 'String'));
        if isnan(newMag), newMag = 100; end;
        handles.axes2AuxHandles.api.setMagnification(handles.axes2AuxHandles.initialMag * newMag/100);
    case handles.magEdit3
        newMag = str2double(get(handles.magEdit3, 'String'));
        if isnan(newMag), newMag = 100; end;
        handles.axes3AuxHandles.api.setMagnification(handles.axes3AuxHandles.initialMag * newMag/100);
end

% --- Executes during object creation, after setting all properties.
function magEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to magEdit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%  computeAxesSizeAndPosition  %%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function computeAxesSizeAndPosition(handles)

% create titles for correct tight inset property value
title(handles.axes1, 'Frontal', 'FontSize', 13);
title(handles.axes2, 'Sagittal', 'FontSize', 13);
title(handles.axes3, 'Transverse', 'FontSize', 13);

% compute image side ratios
handles.xyRatio = size(handles.img, 2) /size(handles.img, 1);
handles.xzRatio = size(handles.img, 2) /size(handles.img, 3);
handles.yzRatio = size(handles.img, 1) /size(handles.img, 3);

% set margin width for axes positioning
marginWidth = 0.025;

% get figure position in pixels and normalized units
set(handles.figure1, 'Units', 'pixel');
figurePosPix = get(handles.figure1, 'Position');
set(handles.figure1, 'Units', 'normalized');
figurePosNorm = get(handles.figure1, 'Position');

% compute absolute figure side ratio
figureWxHRatio = figurePosPix(3) / figurePosPix(4);

% get axes positions and its margins
axes1Pos = get(handles.axes1, 'Position');
axes2Pos = get(handles.axes2, 'Position');
axes3Pos = get(handles.axes3, 'Position');

axes1TightInset = get(handles.axes1, 'TightInset');
axes2TightInset = get(handles.axes2, 'TightInset');
axes3TightInset = get(handles.axes3, 'TightInset');

% compute axes positions
   % compute figure inner margins
leftMargin = max(axes1TightInset(1), axes3TightInset(1)) + marginWidth;
bottomMargin = axes1TightInset(2) + marginWidth;
rightMargin = axes2TightInset(3) + marginWidth;
topMargin = max(axes2TightInset(4), axes3TightInset(4)) + marginWidth;

   % fit axes size with respect to image xy ratio and the main axes (only
   % shortening of sides is allowed)
if handles.xyRatio > 1
    axes3Pos(4) = axes3Pos(3) / handles.xyRatio * figureWxHRatio;
else
    axes3Pos(3) = axes3Pos(4) * handles.xyRatio / figureWxHRatio;
end

axes1Pos(3) = axes3Pos(3);
axes1Pos(4) = axes1Pos(3) / handles.xzRatio * figureWxHRatio;

axes2Pos(4) = axes3Pos(4);
axes2Pos(3) = axes2Pos(4) / handles.yzRatio / figureWxHRatio;

% resize axes to fit given space
sumOfAxesWidth = leftMargin-marginWidth + axes3Pos(3) + axes3TightInset(3) + axes2TightInset(1) + axes2Pos(3) + axes2TightInset(3);
sumOfAxesHeight = axes1TightInset(2) + axes1Pos(4) + axes1TightInset(4) + axes3TightInset(2) + axes3Pos(4) + topMargin-marginWidth;

widthOverlap = sumOfAxesWidth - (0.75 - 3*marginWidth);
heightOverlap = sumOfAxesHeight - (1 - 3*marginWidth);

if widthOverlap > heightOverlap*figureWxHRatio
    if widthOverlap > 0
        resizeCoef = (0.75 - 3*marginWidth) / sumOfAxesWidth;
    else
        resizeCoef = 1;
    end
else
    if heightOverlap > 0
        resizeCoef = (1 - 3*marginWidth) / sumOfAxesHeight;
    else
        resizeCoef = 1;
    end
end

axes1Pos(3:4) = axes1Pos(3:4) * resizeCoef;
axes2Pos(3:4) = axes2Pos(3:4) * resizeCoef;
axes3Pos(3:4) = axes3Pos(3:4) * resizeCoef;

% compute axes position
axes1Pos(1) = leftMargin;
axes1Pos(2) = 1 - topMargin - axes3Pos(4) - axes3TightInset(2) - marginWidth - axes1TightInset(4) - axes1Pos(4);

axes3Pos(1) = leftMargin;
axes3Pos(2) = 1 - topMargin - axes3Pos(4);

axes2Pos(1) = leftMargin + axes3Pos(3) + axes3TightInset(3) + marginWidth + axes2TightInset(1);
axes2Pos(2) = axes3Pos(2);

% set axes new position (position and size)
set(handles.axes1, 'Position', axes1Pos);
set(handles.axes2, 'Position', axes2Pos);
set(handles.axes3, 'Position', axes3Pos);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%  displayFigureButt_Callback  %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in displayFigureButt.
function displayFigureButt_Callback(hObject, eventdata, handles)
% hObject    handle to displayFigureButt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(handles.frontalCheckBox, 'Value') == 1
%         display the actual slice in a new figure
        fig = figure;
        set(fig, 'name', sprintf('Frontal slice No. %d', handles.level(1)), 'numbertitle','off');
        imshow(squeeze(handles.img(handles.level(1),:,:))', [handles.minIntensity handles.maxIntensity]);
        colormap(handles.colormap.actualCmap); hold on;
        
%         draw isoline of the second input matrix (optional)
        if isfield(handles,'ePhi')
            contour(squeeze(handles.ePhi(handles.level(1),:,:))',[handles.isovalues(1) handles.isovalues(1)],'r','LineWidth',2);
        end
%         draw isoline of the third input matrix (optional)
        if isfield(handles,'ePhi2')
            contour(squeeze(handles.ePhi2(handles.level(1),:,:))',[handles.isovalues(2) handles.isovalues(2)],'y:','LineWidth',2);
        end
        
%         axis image;
end

if get(handles.sagittalCheckBox, 'Value') == 1
%         display the actual slice in a new figure
        fig = figure;
        set(fig, 'name', sprintf('Sagittal slice No. %d', handles.level(2)), 'numbertitle','off');
        imshow(squeeze(handles.img(:,handles.level(2),:)), [handles.minIntensity handles.maxIntensity]);
        colormap(handles.colormap.actualCmap); hold on;
        
%         draw isoline of the second input matrix (optional)
        if isfield(handles,'ePhi')
            contour(squeeze(handles.ePhi(:,handles.level(2),:)),[handles.isovalues(1) handles.isovalues(1)],'r','LineWidth',2);
        end
%         draw isoline of the third input matrix (optional)
        if isfield(handles,'ePhi2')
            contour(squeeze(handles.ePhi2(:,handles.level(2),:)),[handles.isovalues(2) handles.isovalues(2)],'y:','LineWidth',2);
        end
        
%         axis image;
end

if get(handles.transversalCheckBox, 'Value') == 1
%         display the actual slice in a new figure
        fig = figure;
        set(fig, 'name', sprintf('Transversal slice No. %d', handles.level(3)), 'numbertitle','off');
        imshow(squeeze(handles.img(:,:,handles.level(3))), [handles.minIntensity handles.maxIntensity]);
        colormap(handles.colormap.actualCmap); hold on;

%         draw isoline of the second input matrix (optional)
        if isfield(handles,'ePhi')
            contour(squeeze(handles.ePhi(:,:,handles.level(3))),[handles.isovalues(1) handles.isovalues(1)],'r','LineWidth',2);
        end
%         draw isoline of the third input matrix (optional)
        if isfield(handles,'ePhi2')
            contour(squeeze(handles.ePhi2(:,:,handles.level(3))),[handles.isovalues(2) handles.isovalues(2)],'y:','LineWidth',2);
        end
        
%         axis image;
end


% --------------------------------------------------------------------
function file_menuItem_Callback(hObject, eventdata, handles)
% hObject    handle to file_menuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function loadDICOMdir_menuItem_Callback(hObject, eventdata, handles)
% hObject    handle to loadDICOMdir_menuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% DICOMdirPath = uigetdir('/mnt/datagrid/Medical/' ,'Select directory including DICOM files');
DICOMdirPath = uigetdir('/home.dokt/kratkj3/Mazanec/final/Viewer/Data/01' ,'Select directory including DICOM files');
 
if isequal(DICOMdirPath,0)
    return;
end

% DICOMdir = dir(fullfile(DICOMdirPath, '*.*'));
DICOMdir = dir(DICOMdirPath);
DICOMdir = DICOMdir(3:end);

filesNum = numel(DICOMdir);
if filesNum == 0,
    warndlg('Selected directory doesnt include any file');
    return;
end

% hWaitbar = waitbar(0,'Loading DICOM files...','WindowStyle', 'modal', 'Name', 'File loading', 'CreateCancelBtn', {@cancelDICOMfilesLoading_Callback, handles});
hWaitbar = waitbar(0,'Loading DICOM files...','WindowStyle', 'modal', 'Name', 'File loading');

A = [];
try
    for i = 1:filesNum
        if DICOMdir(i).isdir
            disp('Dir');
            continue;
        end
        waitbar(i/filesNum);
        DICOMfile = fullfile(DICOMdirPath ,DICOMdir(i).name);
        A(:,:,end+1) = dicomread(DICOMfile);
%                 waitbar(0,hWaitbar,['Loading files...']);
    end
    close(hWaitbar);
    
    A = A(:,:,2:end);
    
    projector13thEd(A);
catch
    errordlg(['Error during loading' DICOMdir(i).name '!'], 'File Error', 'modal');
    close(hWaitbar);
end

% --------------------------------------------------------------------
function cancelDICOMfilesLoading_Callback(hObject, eventdata, handles)
% hObject    handle to loadDICOMdir_menuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

warndlg('Loading of DICOM files was interrupted!', 'File loading interrupted', 'modal');
% get(hObject)
delete(get(hObject, 'Parent'));